> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List runs of a routine

> Run history, newest first.

Required token scopes: `routine|update`



## OpenAPI

````yaml /swagger.json get /base/{baseId}/routine/{routineId}/run
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
tags:
  - name: base
    x-group: project
  - name: base node
    x-group: project node
  - name: base-share
    x-group: project-share
paths:
  /base/{baseId}/routine/{routineId}/run:
    get:
      tags:
        - routine
      summary: List runs of a routine
      description: |-
        Run history, newest first.

        Required token scopes: `routine|update`
      parameters:
        - schema:
            type: string
          required: true
          name: baseId
          in: path
        - schema:
            type: string
          required: true
          name: routineId
          in: path
        - schema:
            type: string
            format: date-time
            description: Inclusive lower bound on createdTime
          required: false
          description: Inclusive lower bound on createdTime
          name: createdTimeStart
          in: query
        - schema:
            type: string
            format: date-time
            description: Inclusive upper bound on createdTime
          required: false
          description: Inclusive upper bound on createdTime
          name: createdTimeEnd
          in: query
        - schema:
            type: string
            enum:
              - pending
              - running
              - success
              - failed
              - canceled
          required: false
          name: status
          in: query
        - schema:
            type: integer
            minimum: 1
            maximum: 100
          required: false
          name: take
          in: query
        - schema:
            type: string
            description: Keyset cursor from the previous page; omit for the first page
          required: false
          description: Keyset cursor from the previous page; omit for the first page
          name: cursor
          in: query
      responses:
        '200':
          description: One page of the run history plus the total row count
          content:
            application/json:
              schema:
                type: object
                properties:
                  runs:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: string
                        routineId:
                          type: string
                        snapshotId:
                          type: string
                        chatId:
                          type: string
                          nullable: true
                        status:
                          type: string
                          enum:
                            - pending
                            - running
                            - success
                            - failed
                            - canceled
                        errorMsg:
                          type: object
                          nullable: true
                          properties:
                            reason:
                              type: string
                              enum:
                                - runFail
                                - timeout
                                - creditExceed
                                - overlap
                                - queueTimeout
                            message:
                              type: string
                          required:
                            - reason
                          additionalProperties:
                            nullable: true
                        plannedAt:
                          type: string
                          nullable: true
                          description: >-
                            The scheduled occurrence this run served; null for a
                            manual run
                        startedAt:
                          type: string
                          nullable: true
                        finishedAt:
                          type: string
                          nullable: true
                        spent:
                          type: number
                          nullable: true
                          description: Execution wall-clock time in ms
                        createdTime:
                          type: string
                      required:
                        - id
                        - routineId
                        - snapshotId
                        - chatId
                        - status
                        - errorMsg
                        - plannedAt
                        - startedAt
                        - finishedAt
                        - spent
                        - createdTime
                  nextCursor:
                    type: string
                    nullable: true
                    description: >-
                      Pass back as `cursor` for the next page; null when
                      exhausted
                required:
                  - runs
                  - nextCursor
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request GET \
              --url 'https://app.teable.ai/api/base/%7BbaseId%7D/routine/%7BroutineId%7D/run?createdTimeStart=SOME_STRING_VALUE&createdTimeEnd=SOME_STRING_VALUE&status=SOME_STRING_VALUE&take=SOME_INTEGER_VALUE&cursor=SOME_STRING_VALUE' \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN'
        - lang: JavaScript
          source: >-
            const url =
            'https://app.teable.ai/api/base/%7BbaseId%7D/routine/%7BroutineId%7D/run?createdTimeStart=SOME_STRING_VALUE&createdTimeEnd=SOME_STRING_VALUE&status=SOME_STRING_VALUE&take=SOME_INTEGER_VALUE&cursor=SOME_STRING_VALUE';

            const options = {method: 'GET', headers: {Authorization: 'Bearer
            REPLACE_BEARER_TOKEN'}};


            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'GET',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/base/%7BbaseId%7D/routine/%7BroutineId%7D/run?createdTimeStart=SOME_STRING_VALUE&createdTimeEnd=SOME_STRING_VALUE&status=SOME_STRING_VALUE&take=SOME_INTEGER_VALUE&cursor=SOME_STRING_VALUE',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            headers = { 'Authorization': "Bearer REPLACE_BEARER_TOKEN" }


            conn.request("GET",
            "/api/base/%7BbaseId%7D/routine/%7BroutineId%7D/run?createdTimeStart=SOME_STRING_VALUE&createdTimeEnd=SOME_STRING_VALUE&status=SOME_STRING_VALUE&take=SOME_INTEGER_VALUE&cursor=SOME_STRING_VALUE",
            headers=headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````